; BRename - rename picked block
; CAD Studio, www.cadstudio.cz - www.cadforum.cz

(vl-load-com)

(defun C:BRename (/ bent bobj oldn dblk match newn cmde)
  (while
    (not
      (and
        (setq bent (entsel "\nSelect Block to rename: ")) ; is selected
        (setq bent (entget (setq bobj (car bent))))
        (setq bobj (vlax-ename->vla-object bobj))
        (= (cdr (assoc 0 bent)) "INSERT") ; is a block
        (setq oldn (cdr (assoc 2 bent)))
        (not (assoc 1 (tblsearch "block" oldn))) ; not an xref
        (setq match (= (strcase oldn)(strcase (setq dblk (vla-get-effectivename bobj))))) ; not a dynamic block
      )
    )
    (prompt "\nNo static Block selected!")
  ) ; while
  (while
    (not
      (and
        (setq newn (getstring T (strcat "\nCurrent name = " oldn (if match "" (strcat " (" dblk ")")) ".  New Block name: ")))
        (not (tblsearch "block" newn)) ; not exists
        (or (= newn "")(snvalid newn)) ; not invalid
      )
    )
    (prompt "\nBlock name already exists or not valid!")
  )
  (if (> newn "") ; entered a new name
    (progn
      (setq cmde (getvar 'cmdecho))
      (setvar "cmdecho" 0)
      (command "_.rename" "_block" oldn newn)
      (prompt "\nRenamed.")
      (setvar "cmdecho" cmde)
    )
  ) ; if
  (princ)
) ; defun
